module Ratr  
  class OmdbHttpWrapper
    INVALID_VALUES = ['N/A']

    attr_reader :url
    def initialize(options = {})
      @url = options.fetch(:url, 'http://www.omdbapi.com')
    end

    def get(movie)
      adapter.get do |request|
        request.url '/'
        request.params['t'] = movie.title
        request.params['y'] = movie.year
      end
    end

    def scrub(responses)
      responses.reduce({}) do |memo, (index, response)|
        rating = response.body['imdbRating']
        memo[index] = []
        memo[index].push(rating.to_f) if rating && !INVALID_VALUES.include?(rating)

        memo
      end
    end

    def adapter
      @adapter ||= Faraday.new(url: url) do |faraday|
        faraday.request  :json
        faraday.response :json
        faraday.adapter  :typhoeus
      end
    end
  end
end
