module Ratr
  class ParallelHttpProcessor
    attr_reader :concurrency, :http_adapter
    def initialize(options={})
      @concurrency = options.fetch(:concurrency, 2)
      @http_adapter = options[:http_adapter]
    end

    def process(&block)
      http_adapter.in_parallel(parallel_manager) do
        block.call
      end
    end

    def parallel_manager
      @parallel_manager ||= Typhoeus::Hydra.new(max_concurrency: concurrency)
    end
  end
end
