module Ratr
  class PoolManager
    attr_reader  :sources, :results, :threads
    def initialize(sources)
      @sources, @results, @threads = sources, [], []
    end

    def process(movies)
      sources.each do |source|
        threads << Thread.new { results << source.fetch(movies) }
      end
    end

    def merged_results
      @merged_results ||= Ratr::ArrayOfHashes.merge(results)
    end

    def join
      threads.each(&:join)
    end
  end
end
