module Ratr
  class Source
    attr_reader :processor, :wrapper
    def initialize(processor, wrapper)
      @wrapper = wrapper
      @processor = processor.new(http_adapter: @wrapper.adapter)
    end

    def fetch(movies)
      responses = {}

      processor.process do
        movies.each do |index, movie|
          responses[index] = wrapper.get(movie)
        end
      end
      wrapper.scrub(responses)
    end
  end
end
